'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = addEntry;

var _fsExtra = require('fs-extra');

var _jsYaml = require('js-yaml');

var _jsYaml2 = _interopRequireDefault(_jsYaml);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function addEntry(_ref, entry) {
  var path = _ref.path,
      components = _ref.components;

  if (entry.component && !Object.keys(components).includes(entry.component)) {
    throw new Error('Unknown component "' + (entry.component || '') + '"');
  }

  var date = new Date();
  var fsFriendlyDateTimeString = toFSFriendlyDateTime(date);
  var readableComponent = entry.component || 'all';
  var fileName = fsFriendlyDateTimeString + '_' + entry.kind + '_' + readableComponent + '.yml';

  (0, _fsExtra.outputFileSync)(path + '/next/' + fileName, _jsYaml2.default.safeDump(_extends({
    dateTime: date.toISOString()
  }, entry)));
}

function toFSFriendlyDateTime(date) {
  return date.toISOString().replace(/:/g, '-');
}