'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = bumpNextVersion;

var _path = require('path');

var _glob = require('glob');

var _fsExtra = require('fs-extra');

var _utils = require('./utils');

function bumpNextVersion(_ref, nextVersionString) {
  var path = _ref.path;

  ensureNextVersionHasEntries(path, nextVersionString);
  ensureVersionDoesNotExist(path, nextVersionString);

  (0, _fsExtra.moveSync)((0, _path.join)(path, 'next'), (0, _path.join)(path, nextVersionString));
}

function ensureNextVersionHasEntries(changelogPath, nextVersionString) {
  if ((0, _glob.sync)((0, _path.join)(changelogPath, 'next', '**/*')).length === 0) {
    throw new Error((0, _utils.multiToSingleLineString)('\n      Cannot release version "next" as ' + nextVersionString + '\n      because it does not contain any entries yet\n      (' + (0, _path.resolve)(changelogPath, 'next') + ')'));
  }
}

function ensureVersionDoesNotExist(changelogPath, nextVersionString) {
  if ((0, _glob.sync)((0, _path.join)(changelogPath, nextVersionString)).length > 0) {
    throw new Error((0, _utils.multiToSingleLineString)('\n      Cannot release version "next" as ' + nextVersionString + '\n      because that version already exists\n      (' + (0, _path.resolve)(changelogPath, nextVersionString) + ')'));
  }
}