'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = connectChangelog;

var _addEntry2 = require('./addEntry');

var _addEntry3 = _interopRequireDefault(_addEntry2);

var _bumpNextVersion2 = require('./bumpNextVersion');

var _bumpNextVersion3 = _interopRequireDefault(_bumpNextVersion2);

var _generate2 = require('./generate');

var _generate3 = _interopRequireDefault(_generate2);

var _getChangelogData2 = require('./getChangelogData');

var _getChangelogData3 = _interopRequireDefault(_getChangelogData2);

var _getPossibleNextVersions = require('./getPossibleNextVersions');

var _getPossibleNextVersions2 = _interopRequireDefault(_getPossibleNextVersions);

var _migrate2 = require('./migrate');

var _migrate3 = _interopRequireDefault(_migrate2);

var _changelogInfo = require('./changelogInfo');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function connectChangelog(config) {
  return {
    addEntry: function addEntry(entry) {
      return (0, _addEntry3.default)(config, entry);
    },
    bumpNextVersion: function bumpNextVersion(nextVersion) {
      return (0, _bumpNextVersion3.default)(config, nextVersion);
    },
    getChangelogData: function getChangelogData() {
      return (0, _getChangelogData3.default)(config);
    },
    generate: function generate() {
      return (0, _generate3.default)(config, (0, _getChangelogData3.default)(config));
    },

    getPossibleNextVersions: _getPossibleNextVersions2.default,
    getComponentsConfig: function getComponentsConfig() {
      return config.components;
    },
    migrate: function migrate() {
      return (0, _migrate3.default)(config);
    },
    getChangelogInfo: function getChangelogInfo() {
      return (0, _changelogInfo.getChangelogInfo)(config);
    },
    saveChangelogInfo: function saveChangelogInfo(newChangelogInfo) {
      return (0, _changelogInfo.saveChangelogInfo)(config, newChangelogInfo);
    }
  };
}