'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getPossibleNextVersions;

var _fsExtra = require('fs-extra');

var _semver = require('semver');

function getPossibleNextVersions() {
  var packageVersion = (0, _fsExtra.existsSync)('package.json') ? (0, _semver.parse)(JSON.parse((0, _fsExtra.readFileSync)('package.json').toString()).version) : null;

  if (!packageVersion) {
    return null;
  }

  var major = packageVersion.major,
      minor = packageVersion.minor,
      patch = packageVersion.patch;


  return [major + '.' + minor + '.' + (patch + 1), major + '.' + (minor + 1) + '.' + patch, major + 1 + '.' + minor + '.' + patch];
}