'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getSortedChangelogVersions;

var _path = require('path');

var _glob = require('glob');

var VERSION_DIRECTORY_NAME_MATCH = /([^\/]+)?\/$/;

function getSortedChangelogVersions(config) {
  return getVersionDirectoryNames(config).map(function (versionDirectoryName) {
    var versionDirectoryMatch = versionDirectoryName.match(VERSION_DIRECTORY_NAME_MATCH);

    if (!versionDirectoryMatch) {
      throw new Error('Could not detect valid version on version directory ' + versionDirectoryName);
    }

    return versionDirectoryMatch[1];
  }).filter(function (versionDirectoryName) {
    return versionDirectoryName !== 'next';
  }).sort().reverse();
}

function getVersionDirectoryNames(_ref) {
  var path = _ref.path;

  return (0, _glob.sync)((0, _path.join)(path, '*/'));
}