'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = migrate;

var _changelogInfo = require('./changelogInfo');

var _migrations = require('./migrations');

var _migrations2 = _interopRequireDefault(_migrations);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function migrate(config) {
  var oldChangelogInfo = (0, _changelogInfo.getChangelogInfo)(config);

  _migrations2.default.slice(oldChangelogInfo.version).forEach(function (migrateNext) {
    migrateNext(config);
  });

  (0, _changelogInfo.saveChangelogInfo)(config, {
    version: _migrations2.default.length
  });

  return {
    from: oldChangelogInfo.version,
    to: _migrations2.default.length
  };
}