'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = toSemVerDirectories;

var _path = require('path');

var _glob = require('glob');

var _fsExtra = require('fs-extra');

// Matches on a path like /path/to/changelog/[whatever]2017-08-23T12:19:14.980Z[whatever].yml
// - 0: matches the file name from the beginning of the ISO string up to the end (extension)
// - 1: matches the file name up to the beginning of the ISO date time string
// - 2: matches the ISO date time string
// - 3: matches the file name from the end of the ISO date time string up to the end (extension)
var ENTRY_FILE_PATH_ISO_DATE_MATCHER = /(.*)([0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}\.[0-9]+Z)([^/\\]*\.yml)$/;

function toSemVerDirectories(config) {
  (0, _glob.sync)((0, _path.join)(config.path, '*/*.yml')).forEach(function (oldFileName) {
    var dateMatches = oldFileName.match(ENTRY_FILE_PATH_ISO_DATE_MATCHER);

    if (!dateMatches) {
      return;
    }

    var _dateMatches$slice = dateMatches.slice(1),
        _dateMatches$slice2 = _slicedToArray(_dateMatches$slice, 3),
        beforeDatePart = _dateMatches$slice2[0],
        datePart = _dateMatches$slice2[1],
        afterPart = _dateMatches$slice2[2];

    (0, _fsExtra.moveSync)(oldFileName, '' + beforeDatePart + datePart.replace(/:/g, '-') + afterPart);
  });
}