'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = cli;

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _api = require('../api');

var _getProjectConfig = require('../getProjectConfig');

var _getProjectConfig2 = _interopRequireDefault(_getProjectConfig);

var _add = require('./commands/add');

var _add2 = _interopRequireDefault(_add);

var _bump = require('./commands/bump');

var _bump2 = _interopRequireDefault(_bump);

var _generate = require('./commands/generate');

var _generate2 = _interopRequireDefault(_generate);

var _migrate = require('./commands/migrate');

var _migrate2 = _interopRequireDefault(_migrate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function cli(args) {
  (0, _yargs2.default)(args).command('add', 'adds a changelog entry', function () {}, withAPI(function (changelog) {
    return (0, _add2.default)(changelog);
  })).command('bump', 'bumps "next" changelog to new version', function (yargs) {
    yargs.option('version', {
      alias: 'v',
      describe: 'next version to bump to'
    });
  }, withAPI(function (changelog, argv) {
    return (0, _bump2.default)(changelog, argv);
  })).command('migrate', 'migrates changelog files to latest version after updating strangelog', function () {}, withAPI(function (changelog) {
    return (0, _migrate2.default)(changelog);
  })).command('generate', 'generates changelog for all versions', function (yargs) {
    yargs.option('outFile', {
      alias: 'f',
      describe: 'name of the changelog file to write',
      // default: 'CHANGELOG.md',
      demandOption: true
    });
  }, withAPI(function (changelog, argv) {
    return (0, _generate2.default)(changelog, argv);
  })).help().argv;
}

function withAPI(commandFunction) {
  return function (argv) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var changelog = (0, _api.connectChangelog)((0, _getProjectConfig2.default)());

    return commandFunction.apply(undefined, [changelog, argv].concat(args));
  };
}