'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(_ref2) {
    var addEntry = _ref2.addEntry,
        getComponentsConfig = _ref2.getComponentsConfig;
    var answers;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return promptEntryInformation(getComponentsConfig());

          case 2:
            answers = _context.sent;


            addEntry(answers);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function runAdd(_x) {
    return _ref.apply(this, arguments);
  }

  return runAdd;
}();

function promptEntryInformation(componentsConfig) {
  var componentKeys = Object.keys(componentsConfig);

  var componentQuestions = componentKeys.length === 0 ? [] : [{
    name: 'component',
    type: 'list',
    message: 'Which component is your change affecting?',
    choices: componentKeys.map(function (componentName) {
      return {
        name: componentsConfig[componentName],
        value: componentName
      };
    })
  }];

  return _inquirer2.default.prompt([].concat(componentQuestions, [{
    name: 'kind',
    type: 'list',
    message: 'What kind of change are you documenting?',
    choices: [{
      name: 'Addition (e.g. new button, new behavior)',
      value: 'addition'
    }, {
      name: 'Change (e.g. change of existing behavior)',
      value: 'change'
    }, {
      name: 'Bug Fix',
      value: 'fix'
    }]
  }, {
    name: 'description',
    type: 'input',
    message: 'What changed?',
    validate: function validate(input) {
      return input.length < 10 ? 'Describe the change in at least 10 characters' : true;
    }
  }]));
}