'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var promptNewVersionInformation = function () {
  var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(_ref4) {
    var getPossibleNextVersions = _ref4.getPossibleNextVersions;
    var possibleNextVersions, versions;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            possibleNextVersions = getPossibleNextVersions();
            versions = possibleNextVersions ? possibleNextVersions.map(function (version) {
              return {
                name: (0, _utils.stringifyVersion)(version),
                value: (0, _utils.stringifyVersion)(version)
              };
            }) : [{
              name: '0.0.1 (Initial Version)',
              value: '0.0.1'
            }];
            return _context2.abrupt('return', _inquirer2.default.prompt([{
              name: 'nextVersion',
              type: 'list',
              message: 'How should the new version be called?',
              choices: versions
            }]));

          case 3:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function promptNewVersionInformation(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _utils = require('../../api/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(changelogAPI, _ref2) {
    var version = _ref2.version;
    var nextVersion;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log('Bumping changelog for "next" version');

            _context.t0 = version;

            if (_context.t0) {
              _context.next = 6;
              break;
            }

            _context.next = 5;
            return promptNewVersionInformation(changelogAPI);

          case 5:
            _context.t0 = _context.sent.nextVersion;

          case 6:
            nextVersion = _context.t0;


            changelogAPI.bumpNextVersion(nextVersion);

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function runBump(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return runBump;
}();