"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = createEntitiesReducer;

var _deepExtend = require("deep-extend");

var _deepExtend2 = _interopRequireDefault(_deepExtend);

var _normalizr = require("normalizr");

require("./actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getInitialState(schemas) {
  function intializeFromSchemas(schemas) {
    return Object.keys(schemas).map(function (nextSchemaName) {
      return schemas[nextSchemaName];
    }).reduce(function (state, nextSchema) {
      return _extends({}, state, _defineProperty({}, nextSchema._key, {}));
    }, {});
  }

  return intializeFromSchemas(schemas);
}

function createEntitiesReducer(schemas) {
  function entitiesReducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getInitialState(schemas);
    var action = arguments[1];

    switch (action.type) {
      case "redux-entitize/UPDATE_ENTITIES":
        return updateEntities(state, action, schemas);
      default:
        return state;
    }
  }

  return entitiesReducer;
}

function updateEntities(state, action, schemas) {
  var _action$payload = action.payload,
      data = _action$payload.data,
      schema = _action$payload.schema;


  if (!data.id) {
    throw new Error("No 'id'-field found in entitiy of schema '" + schema + "'");
  }

  var _normalize = (0, _normalizr.normalize)(data, schemas[schema]),
      entities = _normalize.entities;

  return (0, _deepExtend2.default)({}, state, entities);
}